function Create(self)
   self.mapwrapx = SceneMan.SceneWrapsX;
   self.thrustertimer = Timer();
   self.aimtimer = Timer();
   self.alliedTeam = -2;
   self.halfPi = math.pi*0.5;

   self.releaseFire = false;

   self.thrusterstarttime = 250;
   self.aimchecktime = 100;
   self.detectrange = 3000;
   self.smarthome = true;
   self.turnsharpness = 1.25;
   local launchspeed = 15;
   self.rayDotSpacing = 5;
   self.rayLength = 3000;

   local curdist = 10;
   for i = 1, MovableMan:GetMOIDCount()-1 do
      local gun = MovableMan:GetMOFromID(i);
      if gun.PresetName == "[CHANGEME]" and gun.ClassName == "HDFirearm" and SceneMan:ShortestDistance(self.Pos,ToHDFirearm(gun).MuzzlePos,self.mapwrapx).Magnitude < curdist then
         local flipNum = 1;
         if gun.HFlipped == true then
            flipNum = -1;
         end
         self.Vel = gun.Vel + Vector(launchspeed*flipNum,0):RadRotate(gun.RotAngle);
         self.RotAngle = self.Vel.AbsRadAngle;
         self.parentgun = ToHDFirearm(gun);

         local dots = self.rayLength/self.rayDotSpacing;

         for i = 1, dots do
            local checkPos = self.Pos + Vector(self.Vel.X,self.Vel.Y):SetMagnitude((i/dots)*self.rayLength);
            if SceneMan.SceneWrapsX == true then
               if checkPos.X > SceneMan.SceneWidth then
                  checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
               elseif checkPos.X < 0 then
                  checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
               end
            end
            local terrCheck = SceneMan:GetTerrMatter(checkPos.X,checkPos.Y);
            if terrCheck == 0 then
               local moCheck = SceneMan:GetMOIDPixel(checkPos.X,checkPos.Y);
               if moCheck ~= 255 and MovableMan:GetMOFromID(moCheck).RootID ~= gun.RootID then
                  local checkTarget = MovableMan:GetMOFromID(MovableMan:GetMOFromID(moCheck).RootID);
                  if checkTarget.Team ~= self.Team then
                     self.target = checkTarget;
                     local sfx = CreateAEmitter("[CHANGE ME TOO]");
                     sfx.Pos = self.Pos;
                     MovableMan:AddParticle(sfx);
                     break;
                  end

               end
            else
               break;
            end
         end

         break;

      end
   end

end

function Update(self)

   if self.thrustertimer:IsPastSimMS(self.thrusterstarttime) then
      self:EnableEmission(true);
   end

   if self.target ~= nil and self.target.ID ~= 255 then

      local targetfx = CreateMOSParticle("[CHANGE ME THREE]");
      targetfx.Pos = self.target.Pos;
      MovableMan:AddParticle(targetfx);

      if self.smarthome == true then

         local targetPosition = self.target.Pos;

         if self.target.Vel.Magnitude > 5 then
            local time = SceneMan:ShortestDistance(self.Pos,self.target.Pos,self.mapwrapx).Magnitude / self.Vel.Magnitude;

            local endPoint = Vector(self.target.Vel.Magnitude*time,0):RadRotate(self.target.Vel.AbsRadAngle);
            local distance = endPoint.Magnitude;
            local dotSpacing = 5;
            local dots = distance/dotSpacing;

            for i = 1, dots do
               local checkPos = self.target.Pos + Vector(endPoint.X,endPoint.Y):SetMagnitude((i/dots)*distance);
               if SceneMan.SceneWrapsX == true then
                  if checkPos.X > SceneMan.SceneWidth then
                     checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
                  elseif checkPos.X < 0 then
                     checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
                  end
               end
               local terrCheck = SceneMan:GetTerrMatter(checkPos.X,checkPos.Y);
               if terrCheck == 0 then
                  targetPosition = checkPos;
               else
                  break;
               end
            end

         end

         local aimVector = SceneMan:ShortestDistance(self.Pos,targetPosition,self.mapwrapx);
         local angleCheck = ((aimVector.AbsRadAngle-self.Vel.AbsRadAngle)*self.turnsharpness);
         if math.abs(angleCheck) > self.halfPi then
            self.RotAngle = self.Vel.AbsRadAngle + (self.halfPi*(-1));
         else
            self.RotAngle = aimVector.AbsRadAngle + angleCheck;
         end

      else
         local aimVector = SceneMan:ShortestDistance(self.Pos,self.target.Pos,self.mapwrapx);
         self.RotAngle = aimVector.AbsRadAngle;
      end

   end
   
end